#include<bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr  if(false) cerr
#endif

const int MAX_N = 1e5 + 10;
const int INF = 1e9 + 10;
const int MAX_H = 1e3 + 10; 

int n, m, c, p;
int maxH = 0;
int maxV = 0;
vector <pair<int, int>> v;

int dp[MAX_N][MAX_H];

int main(){
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    #endif
    
    cin >> n >> m >> c >> p;

    int ans = 0;
    for (int i = 0; i < n + m; i ++) {
        int x, y; cin >> x >> y;
        v.push_back({x, y});
        if (x == 1) maxH = max(maxH, y);
        if (x == 2) maxV = max(maxV, y);
    }
    
    dp[0][0] = -INF;
    for (int h = 1; h <= maxH + maxV; h ++) {
        dp[0][h] = -(h - 1) * c;
    }
    
    for (int i = 1; i <= v.size(); i ++) {
        int type = v[i - 1].first;
        int value = v[i - 1].second;
        
        for (int h = 0; h <= maxH + maxV; h ++) {
            dp[i][h] = -INF;

            for (int j = 0; j < h; j ++) {
                dp[i][h] = max(dp[i][h], dp[i][j] - (h - j) * c);
            }

            if (type == 1) {
                if (h + value <= maxH + maxV) dp[i][h] = max(dp[i - 1][h + value], dp[i][h]);
                if (h + value > maxH + maxV)  dp[i][h] = max(dp[i - 1][maxH + maxV] - (h + value - maxH - maxV) * c, dp[i][h]);
            }

    
            if (type == 2) {
                dp[i][h] = dp[i - 1][h];
                if (h >= value) dp[i][h] += p;
            }
            cerr << out(i) << out(h) << out(type) << out(value)  << out(dp[i][h]) << endl;
            ans = max(ans, dp[i][h]);
        }
    }

    cout << ans << endl;

    return 0;
}