#include<bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr  if(false) cerr
#endif

const int MAX_N = 1e6 + 10;
const int INF = 1e9 + 10;

int n, m;
char a[MAX_N];

int g (int x, int y) {
    return x + (y - 1) * m;
}

void move (char dir) {
    if (dir == 'L') {
        for (int y = 1; y <= n; y ++) {
            int fEmpty = -1;
            for (int x = 1; x <= m; x ++) {
                if (fEmpty == -1 && a[g(x, y)] == '.') fEmpty = x;
                if (fEmpty != -1 && a[g(x, y)] != '.') {
                    swap(a[g(x, y)], a[g(fEmpty, y)]);
                    fEmpty ++;
                }
            }
        }
    }   
    if (dir == 'R') {
        for (int y = 1; y <= n; y ++) {
            int fEmpty = -1;
            for (int x = m; x >= 1; x --) {
                if (fEmpty == -1 && a[g(x, y)] == '.') fEmpty = x;
                if (fEmpty != -1 && a[g(x, y)] != '.') {
                    swap(a[g(x, y)], a[g(fEmpty, y)]);
                    fEmpty --;
                }
            }
        }
    }   
    if (dir == 'U') {
        for (int x = 1; x <= m; x ++) {
            int fEmpty = -1;
            for (int y = 1; y <= n; y ++) {
                if (fEmpty == -1 && a[g(x, y)] == '.') fEmpty = y;
                if (fEmpty != -1 && a[g(x, y)] != '.') {
                    swap(a[g(x, y)], a[g(x, fEmpty)]);
                    fEmpty ++;
                }
            }
        }
    }  
    if (dir == 'D') {
        for (int x = 1; x <= m; x ++) {
            int fEmpty = -1;
            for (int y = n; y >= 1; y --) {
                if (fEmpty == -1 && a[g(x, y)] == '.') fEmpty = y;
                if (fEmpty != -1 && a[g(x, y)] != '.') {
                    swap(a[g(x, y)], a[g(x, fEmpty)]);
                    fEmpty --;
                }
            }
        }
    }   
}

void print (bool test) {
    for (int y = 1; y <= n; y ++) {
        for (int x = 1; x <= m; x ++) {
            if (test)  cerr << a[g(x, y)] << " ";
            if (!test) cout << a[g(x, y)];
        }
        
        if (test)  cerr << endl;
        if (!test) cout << endl;
    }

    if (test) cerr << endl;
}

int type (char d) {
    if (d == 'U' || d == 'D') return 1;
    return 2;
}

void solve () {
    cin >> n >> m;
    for (int y = 1; y <= n; y ++) {
        for (int x = 1; x <= m; x ++) {
            cin >> a[g(x, y)];
        }
    }

    // print(true); 

    string s;
    cin >> s;
    string s2;

    bool hadU = false;
    for (int i = 0; i < s.size(); i ++) {
        if (s[i] != 'U') {s2.push_back(s[i]); continue;}
        if (hadU) continue;
        s2.push_back(s[i]);
        hadU = true;
    }
    
    for (int i = 0; i < s2.size(); i ++) {
        if (i == s2.size() - 1 || type(s2[i]) != type(s2[i + 1])) {
            move(s2[i]);
        }
    }

    print(false);

}

int main(){
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    #endif
    
    int TESTS; cin >> TESTS;
    
    for (int i = 0; i < TESTS; i ++) {
        solve();
    }
    return 0;
}


/*
*/