#include <bits/stdc++.h>
using namespace std;

void simulate(vector <vector <char>>& v, char direction) {
    int n = v.size(), m = v[0].size();

    if (direction == 'L') {
        for (int i = 0; i < n; i++) {
            int br = 0;

            for (int j = 0; j < m; j++) {
                if (v[i][j] != '.') {
                    swap(v[i][j], v[i][br]);
                    br++;
                }
            }
        }
    }

    if (direction == 'R') {
        for (int i = 0; i < n; i++) {
            int br = m - 1;

            for (int j = m - 1; j >= 0; j--) {
                if (v[i][j] != '.') {
                    swap(v[i][j], v[i][br]);
                    br--;
                }
            }
        }
    }

    if (direction == 'U') {
        for (int j = 0; j < m; j++) {
            int br = 0;

            for (int i = 0; i < n; i++) {
                if (v[i][j] != '.') {
                    swap(v[i][j], v[br][j]);
                    br++;
                }
            }
        }
    }

    if (direction == 'D') {
        for (int j = 0; j < m; j++) {
            int br = n - 1;

            for (int i = n - 1; i >= 0; i--) {
                if (v[i][j] != '.') {
                    swap(v[i][j], v[br][j]);
                    br--;
                }
            }
        }
    }
}

void output(vector <vector <char>>& v) {
    int n = v.size(), m = v[0].size();

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) cout << v[i][j];
        cout << '\n';
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    for (int q = 0; q < t; q++) {
        int n, m;
        cin >> n >> m;
        vector <vector <char>> v(n, vector <char> (m));

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cin >> v[i][j];
            }
        }

        string s;
        cin >> s;

        for (char direction : s) {
            simulate(v, direction);
        }

        output(v);
    }

    return 0;

}
/**
5 5
abc**
de***
fg***
h****
*****


















4
4 4
.a.b
..e.
....
.cd.
LRU
1 1
.
UULLRRDD
1 6
.a.aa.
LLURDDD
5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
DLDDRULRRR




*/
