# include <iostream>
# include <vector>
# include <algorithm>
using namespace std;

struct edge
{
    int u, v, l=0;
};

struct Move
{
    int u, l;
};

const int MAX=2*1e5+11;
edge a[MAX];
vector<int> g[MAX];
vector<Move> mv;
int d[MAX];
int stat[MAX];///na rebra
int r_stat[MAX];
int p[MAX];///na vurhove
bool ne_barai[MAX];
int n,m;

void reset()
{
    ///napravi reseta kato_horata :)))

    mv.clear();
    for(int i=1;i<=n;i++) g[i].clear();
    for(int i=1;i<=n;i++) p[i]=1;
    for(int i=1;i<=m;i++) stat[i]=0;
    for(int i=1;i<=m;i++) r_stat[i]=0;
    for(int i=1;i<=m;i++) ne_barai[i]=0;
}

int get_st(int u)
{
    if(stat[u]==2) return 1;
    if(stat[u]==0) return 0;
    return 0;
}

void make_move(int u, int l)
{
    cout<<"->"<<u<<" "<<l<<"\n";
    mv.push_back({u,l});
    for(int e: g[u])
    {
        if(p[u]==1) stat[e]--;
        if(l==1) stat[e]++;

        if(stat[e]==2) r_stat[e]=1;
        if(stat[e]==0) r_stat[e]=0;
    }


    p[u]=l;
}

bool check()
{
    for(int i=1;i<=n;i++) if(p[i]!=d[i]) return false;
    for(int i=1;i<=m;i++) if(r_stat[i]!=a[i].l) return false;
    return true;
}

void solve()
{
    cin>>n>>m;
    reset();
    for(int i=1;i<=m;i++)
    {
        cin>>a[i].u>>a[i].v>>a[i].l;
        g[a[i].u].push_back(i);
        g[a[i].v].push_back(i);
    }

    for(int i=1;i<=n;i++)
    {
        p[i]=1;
        cin>>d[i];
    }

    for(int i=1;i<=m;i++)
    {
        if(d[a[i].u]==1 and d[a[i].v]==1 and a[i].l==0)
        {
            ne_barai[a[i].u]=1;
            ne_barai[a[i].v]=1;
        }
    }


    for(int i=1;i<=m;i++)
    {
        int u=a[i].u,v=a[i].v,l=a[i].l;
        if(ne_barai[u]==1 and ne_barai[v]==1) continue;

        if(ne_barai[u]==0 and ne_barai[v]==0)
        {
            if(d[u]==0 and d[v]==0 and l==1) {cout<<"NO"<<"\n";return ;}
        }
        else
        {
            if(ne_barai[u]<ne_barai[v]) swap(u,v);
            if(l==0 and d[v]==1) {cout<<"NO"<<"\n";return ;}
        }
    }

    cout<<"YES"<<"\n";
    cout<<-1<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int t;
    cin>>t;
    while(t--)
    {
        solve();
    }

    return 0;
}

/*
5
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
4 4
1 2 0
2 3 1
3 4 0
4 1 1
0 1 0 1
1 0
1
1 0
0
2 1
1 2 0
0 0
*/

/*
1
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
*/



