#include <bits/stdc++.h>
using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int QUERIES;
    cin >> QUERIES;

    for (int QUERY = 0; QUERY < QUERIES; QUERY++) {
        int n, m;
        cin >> n >> m;

        vector <pair <pair <int, int>, int>> edges_table;
        vector <vector <pair <int, int>>> edges(n + 1);
        vector <bool> visited(n + 1);

        vector <int> vertices(n + 1);

        for (int i = 0; i < m; i++) {
            int a, b, c;
            cin >> a >> b >> c;

            edges_table.push_back({{a, b}, c});
            edges[a].push_back({b, c});
            edges[b].push_back({a, c});
        }

        for (int i = 0; i < n; i++) {
            cin >> vertices[i + 1];
        }

        bool f = true;

        for (int i = 0; i < m; i++) {
            if (edges_table[i].second != vertices[edges_table[i].first.first] && edges_table[i].second != vertices[edges_table[i].first.second]) {
                f = false;
                cout << "NO\n";
                break;
            }
        }

        if (f) {
            cout << "YES\n-1\n";
        }
    }


    return 0;

}
/**

5
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
4 4
1 2 0
2 3 1
3 4 0
4 1 1
0 1 0 1
1 0
1
1 0
0
2 1
1 2 0
0 0

*/
