#include <iostream>
#include <vector>
#include <bitset>
using namespace std;
#define fs first.first
#define sc first.second
#define light second
vector<pair<pair<int, int>, bool>> edge;
vector<pair<int, bool>> action;
int actionCnt = 0;
bitset<100001> lit;

/**
1
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
*/
int main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	for (int c = 0;c < t; c++) {
		int n, m;
		cin >> n >> m;
		lit = 0;
		edge.clear();
		action.clear();
		for (int i = 0; i < m; i++) {
			int a, b;
			bool c;
			cin >> a >> b >> c;
			a--;
			b--;
			edge.push_back({{a, b}, c});
			if (c) {
				if (!lit[a]) {
					lit[a] = 1;
					action.push_back({a, lit[a]});
					actionCnt++;
				}
				if (!lit[b]) {
					lit[b] = 1;
					action.push_back({b, lit[b]});
					actionCnt++;
				}
			}
		}
		for (int i = 0; i < n; i++) {
			bool c;
			cin >> c;
			if (lit[i] != c) {
				lit[i] = c;
				action.push_back({i, lit[i]});
				actionCnt++;
			}
		}
		bool found = 0;
		for (int i = 0; i < m; i++) {
			if (edge[i].light && !lit[edge[i].fs] && !lit[edge[i].sc]) {
				cout << "NO";
				found = 1;
				break;
			}
			if (!edge[i].light && lit[edge[i].fs] && lit[edge[i].sc]) {
				cout << "NO";
				found = 1;
				break;
			}
		}
		if (found) {break;}
		cout << "YES\n";
		cout << action.size() << "\n";
		for (int i = 0; i < action.size(); i++) {
			cout << action[i].first + 1 << " " << action[i].second << "\n";
		}
	}
}
