#include <bits/stdc++.h>
#define llong long long
using namespace std;

const int MAXN = 1e5 + 1;
int N, M;
int C, P;
llong Traps = 0;
vector<llong> Towers;


void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M >> C >> P;

    for(int i = 0; i < N + M; i++)
    {
        int H, Type; cin >> Type >> H;

        if(Type == 1)
        {
            Traps += H;
        }
        else
        {
            Towers.push_back(H + Traps);
        }
    }

    sort(Towers.begin(), Towers.end());
}

void Solve()
{
    llong Answer = 0;
    llong Current = 0;
    llong Robots = 1;

    for(int i = 0; i < (int)Towers.size(); i++)
    {
        Current += (P - C * (Towers[i] - Robots));
        Robots = Towers[i];
        Answer = max(Answer, Current);
    }

    cout << Answer;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
