#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 10;
const int MAXM = 1e5 + 10;
const int MAXC = 1e6 + 10;
const int MAXP = 1e6 + 10;

int n, m;
ll c, p;
pair < int, int > obj[MAXN + MAXM];
vector < int > deliv;

void read()
{
    cin >> n >> m >> c >> p;
    for(int i = 1; i <= n + m; i++)
    {
        cin >> obj[i].first >> obj[i].second;
    }
}

void fill_deliv()
{
    ll hsum = 0;

    for(int i = 1; i <= n + m; i++)
    {
        if(obj[i].first == 1)
        {
            hsum += obj[i].second;
        }
        else
        {
            deliv.push_back(hsum + obj[i].second - 1);
        }
    }
}

void solve()
{
    sort(deliv.begin(), deliv.end());

    ll ans = 0;
    int sz = deliv.size();

    for(int i = 0; i < sz; i++)
    {
        ans = max(ans, (i + 1) * p - deliv[i] * c);
    }

    cout << ans << endl;
}

int main()
{
   ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    fill_deliv();
    solve();

    return 0;
}